#include <bits/stdc++.h>
using namespace std;
int main()
{
    long long n,q,i,j,poc,kr,res;
    bool up=1;
    string niz;
    cin>>n>>q;
    cin>>niz;
    map <long long, long long> brsest,brsedam,brup,brupp,brstp,brsmp;
    for(i=0;i<niz.size();i++)
    {
        if(niz[i]=='6' || niz[i]=='7')
        {
            up=0;
        }
        if(i==0)
        {
            if(niz[0]=='6')
            {
                brsest[0]=1;
                brsedam[0]=0;
                brup[0]=0;
            }
            else if(niz[0]=='7')
            {
                brsest[0]=0;
                brsedam[0]=1;
                brup[0]=0;
            }
            else
            {
                brsest[0]=0;
                brsedam[0]=0;
                brup[0]=1;
            }
        }
        else
        {
            if(niz[i]=='6')
            {
                brsest[i]=brsest[i-1]+1;
                brsedam[i]=brsedam[i-1];
                brup[i]=brup[i-1];
            }
            else if(niz[i]=='7')
            {
                brsest[i]=brsest[i-1];
                brsedam[i]=brsedam[i-1]+1;
                brup[i]=brup[i-1];
            }
            else
            {
                brsest[i]=brsest[i-1];
                brsedam[i]=brsedam[i-1];
                brup[i]=brup[i-1]+1;
            }
        }
    }
    /*for(i=0;i<q;i++)
    {
        cin>>poc>>kr;
        res=0;
        for(j=kr-1;j>=poc-1;j++)
        {
            if(brup[kr-1]==0)
            {

            }
            else if(brup[kr-1]==1)
            {

            }
            else
            {

            }
        }
    }*/
    if(up)
    {
        for(i=0;i<q;i++)
        {
            cin>>poc>>kr;
            if((kr-poc+1)%2==0)
            cout<<(kr-poc+1)/2*(kr-poc+1)/2<<"\n";
            else
            {
                cout<<(kr-poc+1)/2*((kr-poc+1)/2+1)<<"\n";
            }
        }
    }
    else
    {
        for(i=0;i<q;i++)
        {
            res=0;
            cin>>poc>>kr;
            for(j=poc-1;j<kr;j++)
            {
                if(niz[j]=='6')
                res+=brsedam[kr-1]-brsedam[j];
            }
            cout<<res<<"\n";
        }
    }
    return 0;
}